//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "ExpFn.h"

#include "../../C++ Builder 5/Bin/XLS4Report.h"
#include "../../C++ Builder 5/Bin/ExcelReport.h"
#include "../../C++ Builder 5/Bin/SylkReport.h"
#include "../../C++ Builder 5/Bin/WordReport.h"

/*TExpFuncRep*/

//---------------------------------------------------------------------------
__fastcall TExpFuncRep::TExpFuncRep(  TComponent* Owner,
                                      TTtypeReport pTypeOfRep,
                                      HWND phwndOwner,
                                      TCallBackFunc pCallBackFunc,
                                      void* ppSelf) : TComponent(Owner){
  id = (int)this;
  hwndOwner = phwndOwner;
  CallBackFunc = pCallBackFunc;
  pSelf = ppSelf;
  TypeOfRep = pTypeOfRep;
  Intf = NULL;
  CallBackIntf = NULL;
  switch ( TypeOfRep ){
    case ttrXLS4:
      //
      oRep = new TXLS4Report(this);
      break;
    case ttrCOM_XLS:
      //
      oRep = new TExcelReport(this);
      break;
    case ttrSYLK:
      //
      oRep = new TSylkReport(this);
      break;
    case ttrRTF_HTML:
      //
      oRep = new TWordReport(this);
      break;
    default:
      //
      oRep = NULL;
      break;
  };
  if ( oRep ){
    oRep->OnStartReport =       FOnStartReport;
    oRep->OnEndReport =         FOnEndReport;
    oRep->OnReportError =       FOnReportError;
    oRep->OnMoveTop =           FOnMoveTop;
    oRep->OnMoveNext =          FOnMoveNext;
    oRep->OnSectionBegin =      FOnSectionBegin;
    oRep->OnSectionEnd =        FOnSectionEnd;
    oRep->OnSectionComplit =    FOnSectionComplit;
    oRep->OnSectionCheck =      FOnSectionCheck;
    oRep->OnDataRequest =       FOnDataRequest;
    oRep->OnRequestByName =     FOnRequestByName;
    oRep->OnRequestByNum =      FOnRequestByNum;
    oRep->OnSectionPrepare =    FOnSectionPrepare;

    oRep->WriteStreamPtr = NULL;

  };
};

//---------------------------------------------------------------------------
__fastcall TExpFuncRep::TExpFuncRep(  TComponent* Owner,
                                      TTtypeReport pTypeOfRep,
                                      IUnknown*         intf,
                                      TCallBackIntf pCallBackIntf,
                                      void* ppSelf) : TComponent(Owner){
  id = (int)this;
  hwndOwner = NULL;
  CallBackFunc = NULL;
  pSelf = ppSelf;
  TypeOfRep = pTypeOfRep;
  Intf = intf;
  Intf->AddRef();
  CallBackIntf = pCallBackIntf;
  switch ( TypeOfRep ){
    case ttrCOM_XLS:
      //
      oRep = new TExcelReport(this);
      break;
    case ttrSYLK:
      //
      oRep = new TSylkReport(this);
      break;
    case ttrRTF_HTML:
      //
      oRep = new TWordReport(this);
      break;
    default:
      //
      oRep = NULL;
      break;
  };
  if ( oRep ){
    oRep->OnStartReport =       FOnStartReport;
    oRep->OnEndReport =         FOnEndReport;
    oRep->OnReportError =       FOnReportError;
    oRep->OnMoveTop =           FOnMoveTop;
    oRep->OnMoveNext =          FOnMoveNext;
    oRep->OnSectionBegin =      FOnSectionBegin;
    oRep->OnSectionEnd =        FOnSectionEnd;
    oRep->OnSectionComplit =    FOnSectionComplit;
    oRep->OnSectionCheck =      FOnSectionCheck;
    oRep->OnDataRequest =       FOnDataRequest;
    oRep->OnRequestByName =     FOnRequestByName;
    oRep->OnRequestByNum =      FOnRequestByNum;
    oRep->OnSectionPrepare =    FOnSectionPrepare;

    oRep->WriteStreamPtr = NULL;

  };
};

//---------------------------------------------------------------------------
__fastcall TExpFuncRep::~TExpFuncRep(void){
  if (Intf != NULL){
    Intf->Release();
    Intf = NULL;
  };
  if ( oRep != NULL ) oRep->Free();
};

//------------------------------------------------------------------------------
void TExpFuncRep::sendMessage(UINT  uMsg, WPARAM  wParam, LPARAM  lParam){
  if ( ! CallBackIntf ){
    if ( CallBackFunc ){
      (*(CallBackFunc))(id, uMsg, wParam, lParam, pSelf);
    } else {
      SendMessage(hwndOwner, uMsg, wParam, lParam);
    };
  } else {
    (*(CallBackIntf))(Intf, this, uMsg, wParam, lParam, pSelf);
  };
};


//---------------------------------------------------------------------------
void __fastcall TExpFuncRep::FOnStartReport(TObject * Sender){
  sendMessage(WM_REP_START_REPORT, 0, 0);
};

//---------------------------------------------------------------------------
void __fastcall TExpFuncRep::FOnEndReport(TObject * Sender){
  sendMessage(WM_REP_END_REPORT, 0, 0);
};

//---------------------------------------------------------------------------
void __fastcall TExpFuncRep::FOnReportError(TObject * Sender, int mError, int nError, AnsiString sError){
  sendMessage(WM_REP_ERROR, nError, (LPARAM)sError.c_str());
};

//---------------------------------------------------------------------------
void __fastcall TExpFuncRep::FOnMoveTop(TObject * Sender, bool &bCheck){
  int     chk;
  if ( bCheck ){
    chk = -1;
  } else {
    chk = 0;
  };
  sendMessage(WM_REP_MOVE, MOVE_TOP, (LPARAM)(&chk));
  if ( chk ){
    bCheck = true;
  } else {
    bCheck = false;
  };
};

//---------------------------------------------------------------------------
void __fastcall TExpFuncRep::FOnMoveNext(TObject * Sender, bool &bCheck){
  int     chk;
  if ( bCheck ){
    chk = -1;
  } else {
    chk = 0;
  };
  sendMessage(WM_REP_MOVE, MOVE_NEXT, (LPARAM)(&chk));
  if ( chk ){
    bCheck = true;
  } else {
    bCheck = false;
  };
};

//---------------------------------------------------------------------------
void __fastcall TExpFuncRep::FOnSectionBegin(TObject * Sender, AnsiString &SectionName, int SectionNum){
  sendMessage(WM_REP_SECTION_BEGIN, (WPARAM)SectionName.c_str(), (LPARAM)SectionNum);
};

//---------------------------------------------------------------------------
void __fastcall TExpFuncRep::FOnSectionEnd(TObject * Sender, AnsiString &SectionName, int SectionNum){
  sendMessage(WM_REP_SECTION_END, (WPARAM)SectionName.c_str(), (LPARAM)SectionNum);
};
//---------------------------------------------------------------------------
void __fastcall TExpFuncRep::FOnSectionComplit(TObject * Sender, AnsiString &SectionName, int SectionNum){
  sendMessage(WM_REP_SECTION_COMPLIT, (WPARAM)SectionName.c_str(), (LPARAM)SectionNum);
};

//---------------------------------------------------------------------------
void __fastcall TExpFuncRep::FOnSectionCheck(TObject * Sender, AnsiString &SectionName, int SectionNum, bool &bCheck){
  TSectionAttr    S;
  int             chk;
  if ( bCheck ){
    chk = -1;
  } else {
    chk = 0;
  };
  S.SectionName = SectionName.c_str();
  S.SectionNum = SectionNum;
  sendMessage(WM_REP_SECTION_CHECK, (WPARAM)&S, (LPARAM)(&chk));
  if ( chk ){
    bCheck = true;
  } else {
    bCheck = false;
  };
};

//---------------------------------------------------------------------------
void __fastcall TExpFuncRep::FOnDataRequest(TObject * Sender, AnsiString &SectionName, int SectionNum, Variant &sData, bool &bCheck, int OutR, int OutC, int InR, int InC){
  RequestDataStract   RQ;
  int                 i;
  int                 chk;
  if ( bCheck ){
    chk = -1;
  } else {
    chk = 0;
  };
  RQ.SectionName = SectionName.c_str();
  RQ.SectionNum = SectionNum;
  switch ( sData.Type() ){
    case varNull:
    case varEmpty:
      RQ.sDataVarType = vkvtNULL;
      break;
    case varSmallint:
    case varInteger:
      RQ.sDataVarType = vkvtInteger;
      RQ.sDataVarInt = sData;
      break;
    case varBoolean:
      RQ.sDataVarType = vkvtBoolean;
      RQ.sDataVarInt = sData;
      break;
    case varSingle:
    case varDouble:
    case varCurrency:
      RQ.sDataVarType = vkvtInteger;
      RQ.sDataVarInt = sData;
      break;
    case varDate:
      RQ.sDataVarType = vkvtDateTime;
      RQ.sDataVarFloat = sData;
      break;
    case varOleStr:
    case varString:
      RQ.sDataVarType = vkvtStr;
      RQ.sDataVarStr = AnsiString(sData).c_str();
      break;
    default:
      RQ.sDataVarType = vkvtUnassigned;
      break;
  };
  RQ.iP = -1;
  RQ.sField = NULL;

  RQ.sRetDataVarType = vkvtUnassigned;
  for (i=0;i<MAX_CHAR_DATA;i++) RQ.sRetDataVarStr[i] = 0;

  RQ.CurrCell.iRow = OutR;
  RQ.CurrCell.iCol = OutC;
  RQ.BlankCell.iRow = InR;
  RQ.BlankCell.iCol = InC;

  sendMessage(WM_REP_SECTION_DATA_REQUEST, (WPARAM)&RQ, (LPARAM)(&chk));

  //MessageBox(NULL, Format("%d, %d, %d, %d, %f", ARRAYOFCONST(((int)RQ.sDataVarType, (int)RQ.sDataVarInt, (int)RQ.sRetDataVarType, (int)RQ.sRetDataVarInt, (double)RQ.sRetDataVarFloat )) ).c_str(), "@@@", MB_OK);

  if ( chk ){
    bCheck = true;
    sData.Clear();
    switch ( RQ.sRetDataVarType ){
      case vkvtInteger:
        sData = RQ.sRetDataVarInt;
        break;
      case vkvtBoolean:
        if ( RQ.sRetDataVarInt ){
          sData = true;
        } else {
          sData = false;
        };
        break;
      case vkvtDouble:
      case vkvtDateTime:
        sData = RQ.sRetDataVarFloat;
        break;
      case vkvtStr:
        sData = (char*)(&RQ.sRetDataVarStr[0]);
        break;
    };
  } else {
    bCheck = false;
  };
};

//---------------------------------------------------------------------------
void __fastcall TExpFuncRep::FOnRequestByName(TObject * Sender, AnsiString &SectionName, AnsiString &sFieldName, AnsiString &sStr){
  RequestDataStract   RQ;
  int                 i;
  RQ.SectionName = SectionName.c_str();
  RQ.SectionNum = oRep->CurrentSectionNum;
  RQ.sDataVarType = vkvtUnassigned;
  RQ.iP = -1;
  RQ.sField = sFieldName.c_str();
  RQ.sRetDataVarType = vkvtUnassigned;
  for (i=0;i<MAX_CHAR_DATA;i++) RQ.sRetDataVarStr[i] = 0;
  RQ.CurrCell.iRow = 0;
  RQ.CurrCell.iCol = 0;
  RQ.BlankCell.iRow = 0;
  RQ.BlankCell.iCol = 0;
  sendMessage(WM_REP_SECTION_DATA_REQUEST_BY_NAME, (WPARAM)&RQ, 0);
  if ( !((RQ.sRetDataVarType == vkvtUnassigned) || (RQ.sRetDataVarType == vkvtNULL)) ){
    switch ( RQ.sRetDataVarType ){
      case vkvtInteger:
        sStr = IntToStr(RQ.sRetDataVarInt);
        break;
      case vkvtBoolean:
        if ( RQ.sRetDataVarInt ){
          sStr = "true";
        } else {
          sStr = "false";
        };
        break;
      case vkvtDouble:
        sStr = FloatToStr(RQ.sRetDataVarFloat);
        break;
      case vkvtDateTime:
        sStr = DateTimeToStr(RQ.sRetDataVarFloat);
        break;
      case vkvtStr:
        sStr = (char*)(&RQ.sRetDataVarStr[0]);
        break;
    };
  };
};

//---------------------------------------------------------------------------
void __fastcall TExpFuncRep::FOnRequestByNum(TObject * Sender, AnsiString &SectionName, int &iP, AnsiString &sStr){
  int     i;
  RequestDataStract   RQ;
  RQ.SectionName = SectionName.c_str();
  RQ.SectionNum = oRep->CurrentSectionNum;
  RQ.sDataVarType = vkvtUnassigned;
  RQ.iP = iP;
  RQ.sField = NULL;
  RQ.sRetDataVarType = vkvtUnassigned;
  for (i=0;i<MAX_CHAR_DATA;i++) RQ.sRetDataVarStr[i] = 0;
  RQ.CurrCell.iRow = 0;
  RQ.CurrCell.iCol = 0;
  RQ.BlankCell.iRow = 0;
  RQ.BlankCell.iCol = 0;
  sendMessage(WM_REP_SECTION_DATA_REQUEST_BY_NUM, (WPARAM)&RQ, 0);
  if ( !((RQ.sRetDataVarType == vkvtUnassigned) || (RQ.sRetDataVarType == vkvtNULL)) ){
    switch ( RQ.sRetDataVarType ){
      case vkvtInteger:
        sStr = IntToStr(RQ.sRetDataVarInt);
        break;
      case vkvtBoolean:
        if ( RQ.sRetDataVarInt ){
          sStr = "true";
        } else {
          sStr = "false";
        };
        break;
      case vkvtDouble:
        sStr = FloatToStr(RQ.sRetDataVarFloat);
        break;
      case vkvtDateTime:
        sStr = DateTimeToStr(RQ.sRetDataVarFloat);
        break;
      case vkvtStr:
        sStr = (char*)(&RQ.sRetDataVarStr[0]);
        break;
    };
  };
};

//---------------------------------------------------------------------------
void __fastcall TExpFuncRep::FOnSectionPrepare(TObject * Sender){
  sendMessage(WM_REP_SECTION_PREPARE, 0, 0);
};

//---------------------------------------------------------------------------
void __fastcall TExpFuncRep::ReportResume(void){
  oRep->ReportResume();
};

//---------------------------------------------------------------------------
void __fastcall TExpFuncRep::ReportExecute(void){
  oRep->ReportExecute();
};

//---------------------------------------------------------------------------
void __fastcall TExpFuncRep::ReportHorizontalyResume(void){
  oRep->ReportHorizontalyResume();
};

//---------------------------------------------------------------------------
void __fastcall TExpFuncRep::ReportHorizontalyExecute(void){
  oRep->ReportHorizontalyExecute();
};

//---------------------------------------------------------------------------
void __fastcall TExpFuncRep::BiDirectionResume(void){
  oRep->BiDirectionResume();
};

//---------------------------------------------------------------------------
void __fastcall TExpFuncRep::BiDirectionExecute(void){
  oRep->BiDirectionExecute();
};

//---------------------------------------------------------------------------
int __fastcall TExpFuncRep::PrepareSection(const char* SectionName){
  return oRep->PrepareSection(SectionName);
};

//---------------------------------------------------------------------------
int __fastcall TExpFuncRep::PrepareHorizontalySection(const char* SectionName){
  return oRep->PrepareHorizontalySection(SectionName);
};

//---------------------------------------------------------------------------
void __fastcall TExpFuncRep::OutSection(const char* SectionName){
  oRep->OutSection(SectionName);
};

//---------------------------------------------------------------------------
void __fastcall TExpFuncRep::OutHorizontalySection(const char* SectionName){
  oRep->OutHorizontalySection(SectionName);
};

//---------------------------------------------------------------------------
void __fastcall TExpFuncRep::OutSection(int SectionNum){
  oRep->OutSection(SectionNum);
};

//---------------------------------------------------------------------------
void __fastcall TExpFuncRep::OutHorizontalySection(int SectionNum){
  oRep->OutHorizontalySection(SectionNum);
};

//---------------------------------------------------------------------------
char* __fastcall TExpFuncRep::GetInputBlank(void){
  return oRep->InputBlank.c_str();
};

//---------------------------------------------------------------------------
void __fastcall TExpFuncRep::SetInputBlank(const char* Value){
  oRep->InputBlank = Value;
};

//---------------------------------------------------------------------------
char* __fastcall TExpFuncRep::GetInputSheet(void){
  return oRep->InputSheet.c_str();
};

//---------------------------------------------------------------------------
void __fastcall TExpFuncRep::SetInputSheet(const char* Value){
  oRep->InputSheet = Value;
};

//---------------------------------------------------------------------------
char* __fastcall TExpFuncRep::GetOutputBlank(void){
  return oRep->OutputBlank.c_str();
};

//---------------------------------------------------------------------------
void __fastcall TExpFuncRep::SetOutputBlank(const char* Value){
  oRep->OutputBlank = Value;
};

//---------------------------------------------------------------------------
char* __fastcall TExpFuncRep::GetOutputSheet(void){
  return oRep->OutputSheet.c_str();
};

//---------------------------------------------------------------------------
void __fastcall TExpFuncRep::SetOutputSheet(const char* Value){
  oRep->OutputSheet = Value;
};

//---------------------------------------------------------------------------
char __fastcall TExpFuncRep::GetCharByNum(void){
  return oRep->CharByNum;
};

//---------------------------------------------------------------------------
void __fastcall TExpFuncRep::SetCharByNum(const char Value){
  oRep->CharByNum = Value;
};

//---------------------------------------------------------------------------
char __fastcall TExpFuncRep::GetCharByName(void){
  return oRep->CharByName;
};

//---------------------------------------------------------------------------
void __fastcall TExpFuncRep::SetCharByName(const char Value){
  oRep->CharByName = Value;
};

//---------------------------------------------------------------------------
char* __fastcall TExpFuncRep::GetCurrentSection(void){
  return oRep->CurrentSection.c_str();
};

//---------------------------------------------------------------------------
int __fastcall TExpFuncRep::GetCurrentSectionNum(void){
  return oRep->CurrentSectionNum;
};

//---------------------------------------------------------------------------
TTtypeDiraction __fastcall TExpFuncRep::GetTypeDiraction(void){
  return oRep->TypeDiraction;
};

//---------------------------------------------------------------------------
TWriteStream __fastcall TExpFuncRep::GetWriteStream(void){
  return oRep->WriteStreamPtr;
};

//---------------------------------------------------------------------------
void __fastcall TExpFuncRep::SetWriteStream(TWriteStream Value){
  oRep->WriteStreamPtr = Value;
};

//---------------------------------------------------------------------------
TWriteStream __fastcall TExpFuncRep::GetReadStream(void){
  return oRep->ReadStreamPtr;
};

//---------------------------------------------------------------------------
void __fastcall TExpFuncRep::SetReadStream(TWriteStream Value){
  oRep->ReadStreamPtr = Value;
};

//---------------------------------------------------------------------------

#pragma package(smart_init)
