//---------------------------------------------------------------------------

#ifndef ExpFnH
#define ExpFnH

#include "../../C++ Builder 5/Bin/CommonType.h"

/*TExpFuncRep*/
class TExpFuncRep : public TComponent {
private:

  int               id;

  HWND              hwndOwner;
  TCallBackFunc     CallBackFunc;
  void*             pSelf;
  TReportAbstract*  oRep;
  TTtypeReport      TypeOfRep;
  IUnknown*         Intf;
  TCallBackIntf     CallBackIntf;

  void sendMessage(UINT  uMsg, WPARAM  wParam, LPARAM  lParam);

  void __fastcall FOnStartReport(TObject * Sender);
  void __fastcall FOnEndReport(TObject * Sender);
  void __fastcall FOnReportError(TObject * Sender, int mError, int nError, AnsiString sError);
  void __fastcall FOnMoveTop(TObject * Sender, bool &bCheck);
  void __fastcall FOnMoveNext(TObject * Sender, bool &bCheck);
  void __fastcall FOnSectionBegin(TObject * Sender, AnsiString &SectionName, int SectionNum);
  void __fastcall FOnSectionEnd(TObject * Sender, AnsiString &SectionName, int SectionNum);
  void __fastcall FOnSectionComplit(TObject * Sender, AnsiString &SectionName, int SectionNum);
  void __fastcall FOnSectionCheck(TObject * Sender, AnsiString &SectionName, int SectionNum, bool &bCheck);
  void __fastcall FOnDataRequest(TObject * Sender, AnsiString &SectionName, int SectionNum, Variant &sData, bool &bCheck, int OutR, int OutC, int InR, int InC);
  void __fastcall FOnRequestByName(TObject * Sender, AnsiString &SectionName, AnsiString &sFieldName, AnsiString &sStr);
  void __fastcall FOnRequestByNum(TObject * Sender, AnsiString &SectionName, int &iP, AnsiString &sStr);
  void __fastcall FOnSectionPrepare(TObject * Sender);

  TWriteStream __fastcall GetWriteStream(void);
  void __fastcall SetWriteStream(TWriteStream Value);

  TWriteStream __fastcall GetReadStream(void);
  void __fastcall SetReadStream(TWriteStream Value);

  char* __fastcall GetInputBlank(void);
  void __fastcall SetInputBlank(const char* Value);

  char* __fastcall GetInputSheet(void);
  void __fastcall SetInputSheet(const char* Value);

  char* __fastcall GetOutputBlank(void);
  void __fastcall SetOutputBlank(const char* Value);

  char* __fastcall GetOutputSheet(void);
  void __fastcall SetOutputSheet(const char* Value);

  char __fastcall GetCharByNum(void);
  void __fastcall SetCharByNum(const char Value);

  char __fastcall GetCharByName(void);
  void __fastcall SetCharByName(const char Value);

  char* __fastcall GetCurrentSection(void);
  int __fastcall GetCurrentSectionNum(void);

  TTtypeDiraction __fastcall GetTypeDiraction(void);

public:

  __fastcall TExpFuncRep( TComponent* Owner,
                          TTtypeReport pTypeOfRep,
                          HWND phwndOwner,
                          TCallBackFunc pCallBackFunc,
                          void* ppSelf);
  __fastcall TExpFuncRep( TComponent* Owner,
                          TTtypeReport pTypeOfRep,
                          IUnknown*         intf,
                          TCallBackIntf pCallBackIntf,
                          void* ppSelf);
  __fastcall ~TExpFuncRep(void);

  void __fastcall ReportResume(void);
  void __fastcall ReportExecute(void);
  void __fastcall ReportHorizontalyResume(void);
  void __fastcall ReportHorizontalyExecute(void);
  void __fastcall BiDirectionResume(void);
  void __fastcall BiDirectionExecute(void);
  int __fastcall PrepareSection(const char* SectionName);
  int __fastcall PrepareHorizontalySection(const char* SectionName);

  void __fastcall OutSection(const char* SectionName);
  void __fastcall OutHorizontalySection(const char* SectionName);
  void __fastcall OutSection(int SectionNum);
  void __fastcall OutHorizontalySection(int SectionNum);

  __property TWriteStream WriteStreamPtr = { read = GetWriteStream, write = SetWriteStream };

  __property TWriteStream ReadStreamPtr = { read = GetReadStream, write = SetReadStream };

  __property char* CurrentSection = { read = GetCurrentSection };
  __property int CurrentSectionNum = { read = GetCurrentSectionNum };

  __property TTtypeDiraction TypeDiraction = { read = GetTypeDiraction };

  __property int ID = { read = id, write = id};

  __property char* InputBlank = { read = GetInputBlank, write = SetInputBlank };
  __property char* InputSheet = { read = GetInputSheet, write = SetInputSheet };
  __property char* OutputBlank = { read = GetOutputBlank, write = SetOutputBlank };
  __property char* OutputSheet = { read = GetOutputSheet, write = SetOutputSheet };
  __property char CharByNum = { read = GetCharByNum, write = SetCharByNum };
  __property char CharByName = { read = GetCharByName, write = SetCharByName };

};


//---------------------------------------------------------------------------
#endif
