//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "ExpFunc.h"

#include "ExpFn.h"

#pragma package(smart_init)
#pragma link "UtilRpt"
#pragma link "ExpFn"
#pragma link "SSmrtRep"
#pragma link "SmartWordStream"
#pragma link "SylkReport"
#pragma link "WordReport"
#pragma link "ERep"
#pragma link "SylkStream"
#pragma link "ExcelReport"
#pragma link "XLS4Report"


static TExpFuncReports reports;

/*TExpFuncReports*/

//---------------------------------------------------------------------------
__fastcall TExpFuncReports::TExpFuncReports(void){
  RepList = new TComponentList();
};

//---------------------------------------------------------------------------
__fastcall TExpFuncReports::~TExpFuncReports(void){
  RepList->Clear();
  delete RepList;
};

//---------------------------------------------------------------------------
int __fastcall TExpFuncReports::CreateReportObject( TTtypeReport pTypeOfRep,
                                                    HWND phwndOwner,
                                                    TCallBackFunc pCallBackFunc,
                                                    void* pSelf){
  TExpFuncRep*    oRep = new TExpFuncRep(NULL, pTypeOfRep, phwndOwner, pCallBackFunc, pSelf);
  RepList->Add(oRep);
  return oRep->ID;
};

//---------------------------------------------------------------------------
void __fastcall TExpFuncReports::DropReportObject(int idObj){
  RepList->Remove((TExpFuncRep*)idObj);
};


//---------------------------------------------------------------------------


/*   Export functions  */


//Constructor
//---------------------------------------------------------------------------
STDAPI_(int) __export CreateReportObject( TTtypeReport pTypeOfRep,
                                          HWND phwndOwner,
                                          TCallBackFunc pCallBackFunc,
                                          void* pSelf){
  return reports.CreateReportObject(pTypeOfRep, phwndOwner, pCallBackFunc, pSelf);
};

//Destructor
//---------------------------------------------------------------------------
STDAPI_(void) __export DropReportObject(int idObj){
  reports.DropReportObject(idObj);
};

//---------------------------------------------------------------------------
STDAPI_(void) __export ReportResume(int idObj){
  TExpFuncRep*    oRep;
  oRep = (TExpFuncRep*)idObj;
  oRep->ReportResume();
};

//---------------------------------------------------------------------------
STDAPI_(void) __export ReportExecute(int idObj){
  TExpFuncRep*    oRep;
  oRep = (TExpFuncRep*)idObj;
  oRep->ReportExecute();
};

//---------------------------------------------------------------------------
STDAPI_(void) __export ReportHorizontalyResume(int idObj){
  TExpFuncRep*    oRep;
  oRep = (TExpFuncRep*)idObj;
  oRep->ReportHorizontalyResume();
};

//---------------------------------------------------------------------------
STDAPI_(void) __export ReportHorizontalyExecute(int idObj){
  TExpFuncRep*    oRep;
  oRep = (TExpFuncRep*)idObj;
  oRep->ReportHorizontalyExecute();
};

//---------------------------------------------------------------------------
STDAPI_(void) __export BiDirectionResume(int idObj){
  TExpFuncRep*    oRep;
  oRep = (TExpFuncRep*)idObj;
  oRep->BiDirectionResume();
};

//---------------------------------------------------------------------------
STDAPI_(void) __export BiDirectionExecute(int idObj){
  TExpFuncRep*    oRep;
  oRep = (TExpFuncRep*)idObj;
  oRep->BiDirectionExecute();
};

//---------------------------------------------------------------------------
STDAPI_(int) __export PrepareSection(int idObj, const char* SectionName){
  TExpFuncRep*    oRep;
  oRep = (TExpFuncRep*)idObj;
  return oRep->PrepareSection(SectionName);
};

//---------------------------------------------------------------------------
STDAPI_(int)  __export PrepareHorizontalySection(int idObj, const char* SectionName){
  TExpFuncRep*    oRep;
  oRep = (TExpFuncRep*)idObj;
  return oRep->PrepareHorizontalySection(SectionName);
};

//---------------------------------------------------------------------------
STDAPI_(void) __export OutSectionByName(int idObj, const char* SectionName){
  TExpFuncRep*    oRep;
  oRep = (TExpFuncRep*)idObj;
  oRep->OutSection(SectionName);
};

//---------------------------------------------------------------------------
STDAPI_(void) __export OutHorizontalySectionByName(int idObj, const char* SectionName){
  TExpFuncRep*    oRep;
  oRep = (TExpFuncRep*)idObj;
  oRep->OutHorizontalySection(SectionName);
};

//---------------------------------------------------------------------------
STDAPI_(void) __export OutSectionByNum(int idObj, int SectionNum){
  TExpFuncRep*    oRep;
  oRep = (TExpFuncRep*)idObj;
  oRep->OutSection(SectionNum);
};

//---------------------------------------------------------------------------
STDAPI_(void) __export OutHorizontalySectionByNum(int idObj, int SectionNum){
  TExpFuncRep*    oRep;
  oRep = (TExpFuncRep*)idObj;
  oRep->OutHorizontalySection(SectionNum);
};


//Property get/set  functions


//---------------------------------------------------------------------------
STDAPI_(char*) __export GetInputBlank(int idObj){
  TExpFuncRep*    oRep;
  oRep = (TExpFuncRep*)idObj;
  return oRep->InputBlank;
};

//---------------------------------------------------------------------------
STDAPI_(void) __export SetInputBlank(int idObj, char* Value){
  TExpFuncRep*    oRep;
  oRep = (TExpFuncRep*)idObj;
  oRep->InputBlank = Value;
};

//---------------------------------------------------------------------------
STDAPI_(char*) __export GetInputSheet(int idObj){
  TExpFuncRep*    oRep;
  oRep = (TExpFuncRep*)idObj;
  return oRep->InputSheet;
};

//---------------------------------------------------------------------------
STDAPI_(void) __export SetInputSheet(int idObj, char* Value){
  TExpFuncRep*    oRep;
  oRep = (TExpFuncRep*)idObj;
  oRep->InputSheet = Value;
};

//---------------------------------------------------------------------------
STDAPI_(char*) __export GetOutputBlank(int idObj){
  TExpFuncRep*    oRep;
  oRep = (TExpFuncRep*)idObj;
  return oRep->OutputBlank;
};

//---------------------------------------------------------------------------
STDAPI_(void) __export SetOutputBlank(int idObj, char* Value){
  TExpFuncRep*    oRep;
  oRep = (TExpFuncRep*)idObj;
  oRep->OutputBlank = Value;
};

//---------------------------------------------------------------------------
STDAPI_(char*) __export GetOutputSheet(int idObj){
  TExpFuncRep*    oRep;
  oRep = (TExpFuncRep*)idObj;
  return oRep->OutputSheet;
};

//---------------------------------------------------------------------------
STDAPI_(void) __export SetOutputSheet(int idObj, char* Value){
  TExpFuncRep*    oRep;
  oRep = (TExpFuncRep*)idObj;
  oRep->OutputSheet = Value;
};

//---------------------------------------------------------------------------
STDAPI_(char) __export GetCharByNum(int idObj){
  TExpFuncRep*    oRep;
  oRep = (TExpFuncRep*)idObj;
  return oRep->CharByNum;
};

//---------------------------------------------------------------------------
STDAPI_(void) __export SetCharByNum(int idObj, const char Value){
  TExpFuncRep*    oRep;
  oRep = (TExpFuncRep*)idObj;
  oRep->CharByNum = Value;
};

//---------------------------------------------------------------------------
STDAPI_(char) __export GetCharByName(int idObj){
  TExpFuncRep*    oRep;
  oRep = (TExpFuncRep*)idObj;
  return oRep->CharByName;
};

//---------------------------------------------------------------------------
STDAPI_(void) __export SetCharByName(int idObj, const char Value){
  TExpFuncRep*    oRep;
  oRep = (TExpFuncRep*)idObj;
  oRep->CharByName = Value;
};

//---------------------------------------------------------------------------
STDAPI_(char*) __export GetCurrentSection(int idObj){
  TExpFuncRep*    oRep;
  oRep = (TExpFuncRep*)idObj;
  return oRep->CurrentSection;
};

//---------------------------------------------------------------------------
STDAPI_(int) __export GetCurrentSectionNum(int idObj){
  TExpFuncRep*    oRep;
  oRep = (TExpFuncRep*)idObj;
  return oRep->CurrentSectionNum;
};

//---------------------------------------------------------------------------
STDAPI_(TTtypeDiraction) __export GetTypeDiraction(int idObj){
  TExpFuncRep*    oRep;
  oRep = (TExpFuncRep*)idObj;
  return oRep->TypeDiraction;
};

//---------------------------------------------------------------------------
STDAPI_(TWriteStream) __export GetWriteStream(int idObj){
  TExpFuncRep*    oRep;
  oRep = (TExpFuncRep*)idObj;
  return oRep->WriteStreamPtr;
};

//---------------------------------------------------------------------------
STDAPI_(void) __export SetWriteStream(int idObj, TWriteStream Value){
  TExpFuncRep*    oRep;
  oRep = (TExpFuncRep*)idObj;
  oRep->WriteStreamPtr = Value;
};

//---------------------------------------------------------------------------
STDAPI_(TWriteStream) __export GetReadStream(int idObj){
  TExpFuncRep*    oRep;
  oRep = (TExpFuncRep*)idObj;
  return oRep->ReadStreamPtr;
};

//---------------------------------------------------------------------------
STDAPI_(void) __export SetReadStream(int idObj, TWriteStream Value){
  TExpFuncRep*    oRep;
  oRep = (TExpFuncRep*)idObj;
  oRep->ReadStreamPtr = Value;
};

//---------------------------------------------------------------------------
STDAPI_(void) __export Test(RequestDataStract& q){
};

//---------------------------------------------------------------------------
#pragma package(smart_init)
