// VKREPORTIMPL : Implementation of TVKReportImpl (CoClass: VKReport, Interface: IVKReport)

#include <vcl.h>
#pragma hdrstop

#include "VKREPORTIMPL.H"
#include "../../C++ Builder 5/Bin/ExcelReport.h"
#include "../../C++ Builder 5/Bin/XLS4Report.h"
#include "../../C++ Builder 5/Bin/SylkReport.h"
#include "../../C++ Builder 5/Bin/WordReport.h"

/////////////////////////////////////////////////////////////////////////////
// TVKReportImpl

STDMETHODIMP TVKReportImpl::BiDirectionExecute()
{
  if ( oRep )
    oRep->BiDirectionExecute();
  return S_OK;
}

STDMETHODIMP TVKReportImpl::BiDirectionResume()
{
  if ( oRep )
      oRep->BiDirectionResume();
  return S_OK;
}

STDMETHODIMP TVKReportImpl::get_CharByName(unsigned_char* Value)
{
  try
  {
    if ( oRep )
      *Value = oRep->CharByName;
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_IVKReport);
  }
  return S_OK;
};


STDMETHODIMP TVKReportImpl::get_CharByNum(unsigned_char* Value)
{
  try
  {
    if ( oRep )
      *Value =  oRep->CharByNum;
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_IVKReport);
  }
  return S_OK;
};


STDMETHODIMP TVKReportImpl::get_CurrentSection(TVariant* Value)
{
  try
  {
    if ( oRep )
      *Value =  oRep->CurrentSection;
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_IVKReport);
  }
  return S_OK;
};


STDMETHODIMP TVKReportImpl::get_CurrentSectionNum(TVariant* Value)
{
  try
  {
    if ( oRep )
      *Value = oRep->CurrentSectionNum;
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_IVKReport);
  }
  return S_OK;
};


STDMETHODIMP TVKReportImpl::get_InputBlank(TVariant* Value)
{
  try
  {
    if ( oRep )
      *Value = oRep->InputBlank;
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_IVKReport);
  }
  return S_OK;
};


STDMETHODIMP TVKReportImpl::get_InputSheet(TVariant* Value)
{
  try
  {
    if ( oRep )
      *Value = oRep->InputSheet;
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_IVKReport);
  }
  return S_OK;
};


STDMETHODIMP TVKReportImpl::get_InputStream(LPUNKNOWN* Value)
{
  try
  {
    *Value = NULL;
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_IVKReport);
  }
  return S_OK;
};


STDMETHODIMP TVKReportImpl::get_OutputBlank(TVariant* Value)
{
  try
  {
    if ( oRep )
      *Value = oRep->OutputBlank;
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_IVKReport);
  }
  return S_OK;
};


STDMETHODIMP TVKReportImpl::get_OutputSheet(TVariant* Value)
{
  try
  {
    if ( oRep )
      *Value = oRep->OutputSheet;
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_IVKReport);
  }
  return S_OK;
};


STDMETHODIMP TVKReportImpl::get_OutputStream(LPUNKNOWN* Value)
{
  try
  {
    *Value = NULL;
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_IVKReport);
  }
  return S_OK;
};


STDMETHODIMP TVKReportImpl::get_TypeDiraction(TtypeDiraction* Value)
{
  try
  {
    if ( oRep )
      *Value = (TtypeDiraction)(oRep->TypeDiraction);
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_IVKReport);
  }
  return S_OK;
};


STDMETHODIMP TVKReportImpl::get_TypeReport(TtypeReport* Value)
{
  try
  {
    if ( oRep ){
      *Value = FTapyReport;
    } else {
      *Value = ittrNotDefined;
    };
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_IVKReport);
  }
  return S_OK;
};


STDMETHODIMP TVKReportImpl::OutHorizontalySectionByName(
  TVariantInParam SectionName)
{
  if ( oRep )
    oRep->OutHorizontalySection(AnsiString(SectionName));
  return S_OK;
}

STDMETHODIMP TVKReportImpl::OutHorizontalySectionByNum(
  TVariantInParam SectionNum)
{
  if ( oRep )
    oRep->OutHorizontalySection((int)SectionNum);
  return S_OK;
}

STDMETHODIMP TVKReportImpl::OutSectionByName(TVariantInParam SectionName)
{
  if ( oRep )
    oRep->OutSection(AnsiString(SectionName));
  return S_OK;
}

STDMETHODIMP TVKReportImpl::OutSectionByNum(TVariantInParam SectionNum)
{
  if ( oRep )
    oRep->OutSection((int)SectionNum);
  return S_OK;
}

STDMETHODIMP TVKReportImpl::PrepareHorizontalySection(
  TVariantInParam SectionName, TVariant* SectionNum)
{
  if ( oRep ){
    *SectionNum = oRep->PrepareHorizontalySection(AnsiString(SectionName));
  } else {
    *SectionNum = -1;
  };
  return S_OK;
}

STDMETHODIMP TVKReportImpl::PrepareSection(TVariantInParam SectionName,
  TVariant* SectionNum)
{
  if ( oRep ){
    *SectionNum = oRep->PrepareSection(AnsiString(SectionName));
  } else {
    *SectionNum = -1;
  };
  return S_OK;
}

STDMETHODIMP TVKReportImpl::ReportExecute()
{
  if ( oRep )
    oRep->ReportExecute();
  return S_OK;
};

STDMETHODIMP TVKReportImpl::ReportHorizontalyExecute()
{
  if ( oRep )
    oRep->ReportHorizontalyExecute();
  return S_OK;
}

STDMETHODIMP TVKReportImpl::ReportHorizontalyResume()
{
  if ( oRep )
    oRep->ReportHorizontalyResume();
  return S_OK;
}

STDMETHODIMP TVKReportImpl::ReportResume()
{
  if ( oRep )
    oRep->ReportResume();
  return S_OK;
}

STDMETHODIMP TVKReportImpl::RequestAll(TVariantInParam RStr,
  TVariantInParam RCheck)
{
  check = RCheck;
  RetStr = RStr;
  return S_OK;
}

STDMETHODIMP TVKReportImpl::RequestCheck(TVariantInParam RCheck)
{
  check = RCheck;
  return S_OK;
}

STDMETHODIMP TVKReportImpl::RequestSTR(TVariantInParam RStr)
{
  RetStr = RStr;
  return S_OK;
}

STDMETHODIMP TVKReportImpl::set_CharByName(unsigned_char Value)
{
  try
  {
    if ( oRep )
      oRep->CharByName = Value;
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_IVKReport);
  }
  return S_OK;
};


STDMETHODIMP TVKReportImpl::set_CharByNum(unsigned_char Value)
{
  try
  {
    if ( oRep )
      oRep->CharByNum = Value;
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_IVKReport);
  }
  return S_OK;
};


STDMETHODIMP TVKReportImpl::set_CurrentSection(TVariantInParam Value)
{
  try
  {
    //
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_IVKReport);
  }
  return S_OK;
};


STDMETHODIMP TVKReportImpl::set_CurrentSectionNum(TVariantInParam Value)
{
  try
  {
    //
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_IVKReport);
  }
  return S_OK;
};


STDMETHODIMP TVKReportImpl::set_InputBlank(TVariantInParam Value)
{
  try
  {
    if ( oRep )
      oRep->InputBlank = Value;
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_IVKReport);
  }
  return S_OK;
};


STDMETHODIMP TVKReportImpl::set_InputSheet(TVariantInParam Value)
{
  try
  {
    if ( oRep )
      oRep->InputSheet = Value;
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_IVKReport);
  }
  return S_OK;
};


STDMETHODIMP TVKReportImpl::set_InputStream(LPUNKNOWN Value)
{
  try
  {
    if ( oRep )
      oRep->InputStream = new TOleStream((IStream*)Value);
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_IVKReport);
  }
  return S_OK;
};


STDMETHODIMP TVKReportImpl::set_OutputBlank(TVariantInParam Value)
{
  try
  {
    if ( oRep )
      oRep->OutputBlank = Value;
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_IVKReport);
  }
  return S_OK;
};


STDMETHODIMP TVKReportImpl::set_OutputSheet(TVariantInParam Value)
{
  try
  {
    if ( oRep )
      oRep->OutputSheet = Value;
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_IVKReport);
  }
  return S_OK;
};


STDMETHODIMP TVKReportImpl::set_OutputStream(LPUNKNOWN Value)
{
  try
  {
    if ( oRep )
      oRep->OutputStream = new TOleStream((IStream*)Value);
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_IVKReport);
  }
  return S_OK;
};


STDMETHODIMP TVKReportImpl::set_TypeDiraction(TtypeDiraction Value)
{
  try
  {
    //
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_IVKReport);
  }
  return S_OK;
};


STDMETHODIMP TVKReportImpl::set_TypeReport(TtypeReport Value)
{
  try
  {
    if ( oRep ) oRep->Free();
    oRep = NULL;

    FTapyReport = Value;

    switch ( FTapyReport ){
      case ittrXLS4:
        //
        oRep = new TXLS4Report(Application);
        break;
      case ittrCOM_XLS:
        //
        oRep = new TExcelReport(Application);
        break;
      case ittrSYLK:
        //
        oRep = new TSylkReport(Application);
        break;
      case ittrRTF_HTML:
        //
        oRep = new TWordReport(Application);
        break;
      default:
        //
        oRep = NULL;
        FTapyReport = ittrNotDefined;
        break;
    };

    if ( oRep ){

      oRep->OnStartReport =       FOnStartReport;
      oRep->OnEndReport =         FOnEndReport;
      oRep->OnReportError =       FOnReportError;
      oRep->OnMoveTop =           FOnMoveTop;
      oRep->OnMoveNext =          FOnMoveNext;
      oRep->OnSectionBegin =      FOnSectionBegin;
      oRep->OnSectionEnd =        FOnSectionEnd;
      oRep->OnSectionComplit =    FOnSectionComplit;
      oRep->OnSectionCheck =      FOnSectionCheck;
      oRep->OnDataRequest =       FOnDataRequest;
      oRep->OnRequestByName =     FOnRequestByName;
      oRep->OnRequestByNum =      FOnRequestByNum;
      oRep->OnSectionPrepare =    FOnSectionPrepare;

    };

  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_IVKReport);
  }
  return S_OK;
};

void __fastcall TVKReportImpl::FOnStartReport(TObject * Sender){
  Fire_OnStartReport();
};

void __fastcall TVKReportImpl::FOnEndReport(TObject * Sender){
  Fire_OnEndReport();
};

void __fastcall TVKReportImpl::FOnReportError(TObject * Sender, int mError, int nError, AnsiString sError){
  Fire_OnReportError(mError, nError, sError);
};

void __fastcall TVKReportImpl::FOnMoveTop(TObject * Sender, bool &bCheck){
  check = bCheck;
  Fire_OnMoveTop();
  bCheck = check;
};

void __fastcall TVKReportImpl::FOnMoveNext(TObject * Sender, bool &bCheck){
  check = bCheck;
  Fire_OnMoveNext();
  bCheck = check;
};

void __fastcall TVKReportImpl::FOnSectionBegin(TObject * Sender, AnsiString &SectionName, int SectionNum){
  Fire_OnSectionBegin(SectionName, SectionNum);
};

void __fastcall TVKReportImpl::FOnSectionEnd(TObject * Sender, AnsiString &SectionName, int SectionNum){
  Fire_OnSectionEnd(SectionName, SectionNum);
};

void __fastcall TVKReportImpl::FOnSectionComplit(TObject * Sender, AnsiString &SectionName, int SectionNum){
  Fire_OnSectionComplit(SectionName, SectionNum);
};

void __fastcall TVKReportImpl::FOnSectionCheck(TObject * Sender, AnsiString &SectionName, int SectionNum, bool &bCheck){
  check = bCheck;
  Fire_OnSectionCheck(SectionName, SectionNum);
  bCheck = check;
};

void __fastcall TVKReportImpl::FOnDataRequest(TObject * Sender, AnsiString &SectionName, int SectionNum, Variant &sData, bool &bCheck, int OutR, int OutC, int InR, int InC){
  check = bCheck;
  RetStr = sData;
  Fire_OnDataRequest(SectionName, SectionNum, sData, OutR, OutC, InR, InC);
  bCheck = check;
  sData = RetStr;
};

void __fastcall TVKReportImpl::FOnRequestByName(TObject * Sender, AnsiString &SectionName, AnsiString &sFieldName, AnsiString &sStr){
  RetStr = sStr;
  Fire_OnRequestByName(SectionName, oRep->CurrentSectionNum, sFieldName);
  sStr = RetStr;
};

void __fastcall TVKReportImpl::FOnRequestByNum(TObject * Sender, AnsiString &SectionName, int &iP, AnsiString &sStr){
  RetStr = sStr;
  Fire_OnRequestByNum(SectionName, oRep->CurrentSectionNum, iP);
  sStr = RetStr;
};

void __fastcall TVKReportImpl::FOnSectionPrepare(TObject * Sender){
  Fire_OnSectionPrepare();
};

