// VKREPORTIMPL.H : Declaration of the TVKReportImpl

#ifndef VKReportImplH
#define VKReportImplH

#include "VKRep_TLB.H"
#include "../../C++ Builder 5/Bin/CommonType.h"


/////////////////////////////////////////////////////////////////////////////
// TVKReportImpl     Implements IVKReport, default interface of VKReport
//                  and IVKReportEvents, the default source interface
// ThreadingModel : Free
// Dual Interface : TRUE
// Event Support  : TRUE
// Default ProgID : VKRep.VKReport
// Description    : OLE Automation object for generate reports to Microsoft Winword RTF,  HTML, Excel SYLK and Excel XLS formats.
/////////////////////////////////////////////////////////////////////////////
class ATL_NO_VTABLE TVKReportImpl :
  public CComObjectRootEx<CComMultiThreadModel>,
  public CComCoClass<TVKReportImpl, &CLSID_VKReport>,
  public IConnectionPointContainerImpl<TVKReportImpl>,
  public TEvents_VKReport<TVKReportImpl>,
  public IDispatchImpl<IVKReport, &IID_IVKReport, &LIBID_VKRep>
{
private:

  TReportAbstract*  oRep;
  TtypeReport       FTapyReport;
  bool              check;
  Variant           RetStr;

  void __fastcall FOnStartReport(TObject * Sender);
  void __fastcall FOnEndReport(TObject * Sender);
  void __fastcall FOnReportError(TObject * Sender, int mError, int nError, AnsiString sError);
  void __fastcall FOnMoveTop(TObject * Sender, bool &bCheck);
  void __fastcall FOnMoveNext(TObject * Sender, bool &bCheck);
  void __fastcall FOnSectionBegin(TObject * Sender, AnsiString &SectionName, int SectionNum);
  void __fastcall FOnSectionEnd(TObject * Sender, AnsiString &SectionName, int SectionNum);
  void __fastcall FOnSectionComplit(TObject * Sender, AnsiString &SectionName, int SectionNum);
  void __fastcall FOnSectionCheck(TObject * Sender, AnsiString &SectionName, int SectionNum, bool &bCheck);
  void __fastcall FOnDataRequest(TObject * Sender, AnsiString &SectionName, int SectionNum, Variant &sData, bool &bCheck, int OutR, int OutC, int InR, int InC);
  void __fastcall FOnRequestByName(TObject * Sender, AnsiString &SectionName, AnsiString &sFieldName, AnsiString &sStr);
  void __fastcall FOnRequestByNum(TObject * Sender, AnsiString &SectionName, int &iP, AnsiString &sStr);
  void __fastcall FOnSectionPrepare(TObject * Sender);

public:
  TVKReportImpl()
  {
    oRep = NULL;
    FTapyReport = ittrNotDefined;
  }

  ~TVKReportImpl()
  {
    if ( oRep ) oRep->Free();
    oRep = NULL;
  }
  // Data used when registering Object
  //
  DECLARE_THREADING_MODEL(otFree);
  DECLARE_PROGID("VKRep.VKReport");
  DECLARE_DESCRIPTION("OLE Automation object for generate reports to Microsoft Winword RTF,  HTML, Excel SYLK and Excel XLS formats.");

  // Function invoked to (un)register object
  //
  static HRESULT WINAPI UpdateRegistry(BOOL bRegister)
  {
    TTypedComServerRegistrarT<TVKReportImpl> 
    regObj(GetObjectCLSID(), GetProgID(), GetDescription());
    return regObj.UpdateRegistry(bRegister);
  }


BEGIN_COM_MAP(TVKReportImpl)
  COM_INTERFACE_ENTRY(IVKReport)
  COM_INTERFACE_ENTRY2(IDispatch, IVKReport)
  COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
END_COM_MAP()

BEGIN_CONNECTION_POINT_MAP(TVKReportImpl)
  CONNECTION_POINT_ENTRY(DIID_IVKReportEvents)
END_CONNECTION_POINT_MAP()

// IVKReport
public:

  STDMETHOD(BiDirectionExecute());
  STDMETHOD(BiDirectionResume());
  STDMETHOD(get_CharByName(unsigned_char* Value));
  STDMETHOD(get_CharByNum(unsigned_char* Value));
  STDMETHOD(get_CurrentSection(TVariant* Value));
  STDMETHOD(get_CurrentSectionNum(TVariant* Value));
  STDMETHOD(get_InputBlank(TVariant* Value));
  STDMETHOD(get_InputSheet(TVariant* Value));
  STDMETHOD(get_InputStream(LPUNKNOWN* Value));
  STDMETHOD(get_OutputBlank(TVariant* Value));
  STDMETHOD(get_OutputSheet(TVariant* Value));
  STDMETHOD(get_OutputStream(LPUNKNOWN* Value));
  STDMETHOD(get_TypeDiraction(TtypeDiraction* Value));
  STDMETHOD(get_TypeReport(TtypeReport* Value));
  STDMETHOD(OutHorizontalySectionByName(TVariantInParam SectionName));
  STDMETHOD(OutHorizontalySectionByNum(TVariantInParam SectionNum));
  STDMETHOD(OutSectionByName(TVariantInParam SectionName));
  STDMETHOD(OutSectionByNum(TVariantInParam SectionNum));
  STDMETHOD(PrepareHorizontalySection(TVariantInParam SectionName,
      TVariant* SectionNum));
  STDMETHOD(PrepareSection(TVariantInParam SectionName,
      TVariant* SectionNum));
  STDMETHOD(ReportExecute());
  STDMETHOD(ReportHorizontalyExecute());
  STDMETHOD(ReportHorizontalyResume());
  STDMETHOD(ReportResume());
  STDMETHOD(RequestAll(TVariantInParam RStr, TVariantInParam RCheck));
  STDMETHOD(RequestCheck(TVariantInParam RCheck));
  STDMETHOD(RequestSTR(TVariantInParam RStr));
  STDMETHOD(set_CharByName(unsigned_char Value));
  STDMETHOD(set_CharByNum(unsigned_char Value));
  STDMETHOD(set_CurrentSection(TVariantInParam Value));
  STDMETHOD(set_CurrentSectionNum(TVariantInParam Value));
  STDMETHOD(set_InputBlank(TVariantInParam Value));
  STDMETHOD(set_InputSheet(TVariantInParam Value));
  STDMETHOD(set_InputStream(LPUNKNOWN Value));
  STDMETHOD(set_OutputBlank(TVariantInParam Value));
  STDMETHOD(set_OutputSheet(TVariantInParam Value));
  STDMETHOD(set_OutputStream(LPUNKNOWN Value));
  STDMETHOD(set_TypeDiraction(TtypeDiraction Value));
  STDMETHOD(set_TypeReport(TtypeReport Value));
};

#endif //VKReportImplH
